package org.foxarmy.barcodescannerforemployees.dataclasses

import android.os.Parcel
import android.os.Parcelable

class Product() : Parcelable {
    var id = 0
    var abstractProductId = 0
    var amount = 0
    var dateOfProduction = "01.01.1970"
    var dateOfExpiry = "01.01.1970"

    constructor(id: Int, abstractProductId: Int, amount: Int, dateOfProduction: String, dateOfExpiry: String) : this() {
        this.id = id
        this.abstractProductId = abstractProductId
        this.amount = amount
        this.dateOfProduction = dateOfProduction
        this.dateOfExpiry = dateOfExpiry
    }

    constructor(parcel: Parcel) : this() {
        id = parcel.readInt()
        abstractProductId = parcel.readInt()
        amount = parcel.readInt()
        dateOfProduction = parcel.readString()!!
        dateOfExpiry = parcel.readString()!!
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeInt(id)
        parcel.writeInt(abstractProductId)
        parcel.writeInt(amount)
        parcel.writeString(dateOfProduction)
        parcel.writeString(dateOfExpiry)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<Product> {
        override fun createFromParcel(parcel: Parcel): Product {
            return Product(parcel)
        }

        override fun newArray(size: Int): Array<Product?> {
            return arrayOfNulls(size)
        }
    }
}